from django.contrib import admin
from erp.assets.networkfunctions import buscar_informacoes,add_days,ler_csv
from django.contrib import messages
from django.utils import timezone
from erp.models import Estoque,Imagemestoque,Tag

from django.core.files import File

#from django.shortcuts import get_object_or_404,render,redirect

@admin.action(description='Importar dados da Ludopédia')
def importa_jogos(modeladmin,request,queryset):
    for jogo in queryset:
        #Prepara nome para solicitacao na internet
        if jogo.nomeludopedia:
            nome = jogo.nomeludopedia
        else:
            nome = jogo.nome
            nome = nome.replace(' ','-').lower()
        #Faz solicitacao
        dados = buscar_informacoes(nome)
        if dados == 'error(naoencontrado)':
            messages.error(request,f'Jogo: {jogo.nome} não encontrado na Ludopedia. Provavelmente o nome nao bate com o da Ludopedia.')
        else:
            jogo.descricao = dados[4]
            jogo.tempodejogo = int(dados[2].split()[0])
            list_jogadores=dados[3].strip().split(' ')
            if len(list_jogadores)>=4:
                jogo.minjogadores = int(dados[3].split(' ')[0])
                jogo.maxjogadores = int(dados[3].split(' ')[2])
            else:
                jogo.minjogadores = int(dados[3].split(' ')[0])
                jogo.maxjogadores = 0
            #lista_idade = dados[1].split()
            jogo.idade = dados[1][6:]
            #se nao tem nome da ludopedia,e achou coloca o nome 
            if not jogo.nomeludopedia:
                jogo.nomeludopedia = nome
            messages.success(request,f'Jogo: {jogo.nome} importado da Ludopedia')
            jogo.save()


#Gerencia de status do pedido via admin panel:
@admin.action(description='Marcar pedidos em dinheiro como pago')
def paga_pedidos(modelamin,request,queryset):
    queryset.update(status="Pago",dtpago=add_days(0),controlpago=True)
    messages.success(request,f'{queryset.count()} pedido(s) selecionas marcados como Pago')

@admin.action(description='Entregar pedidos')
def entrega_pedidos(modelamin,request,queryset):
    #It has to be save to make sure it updates estoque
    for pedido in queryset:
        pedido.status="Entregue"
        pedido.save()
    messages.success(request,f'{queryset.count()} pedido(s) selecionas marcados como Entregue')

@admin.action(description='Retornar pedidos')
def retorno_pedidos(modelamin,request,queryset):
    #It has to be save to make sure it updates estoque
    for pedido in queryset:
        pedido.status = "Retornado"
        pedido.save()
    messages.success(request,f'{queryset.count()} pedido(s) selecionas marcados como Retornado')

@admin.action(description='Finalizar pedidos')
def finaliza_pedidos(modelamin,request,queryset):
    #It has to be save to make sure it updates estoque
    for pedido in queryset:
        pedido.status="Finalizado"
        pedido.save()
    messages.success(request,f'{queryset.count()} pedido(s) selecionas marcados como Finalizado')
